/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the Wait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Wait{}

// Wait 
type Wait struct {
	Duration *string `json:"duration,omitempty"`
	Until *WaitUntil `json:"until,omitempty"`
	// Whether reaching deadline means action failed or succeeded
	FailOnReach bool `json:"fail_on_reach"`
}

// NewWait instantiates a new Wait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWait(failOnReach bool) *Wait {
	this := Wait{}
	this.FailOnReach = failOnReach
	return &this
}

// NewWaitWithDefaults instantiates a new Wait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWaitWithDefaults() *Wait {
	this := Wait{}
	return &this
}

// GetDuration returns the Duration field value if set, zero value otherwise.
func (o *Wait) GetDuration() string {
	if o == nil || IsNil(o.Duration) {
		var ret string
		return ret
	}
	return *o.Duration
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Wait) GetDurationOk() (*string, bool) {
	if o == nil || IsNil(o.Duration) {
		return nil, false
	}
	return o.Duration, true
}

// HasDuration returns a boolean if a field has been set.
func (o *Wait) HasDuration() bool {
	if o != nil && !IsNil(o.Duration) {
		return true
	}

	return false
}

// SetDuration gets a reference to the given string and assigns it to the Duration field.
func (o *Wait) SetDuration(v string) {
	o.Duration = &v
}

// GetUntil returns the Until field value if set, zero value otherwise.
func (o *Wait) GetUntil() WaitUntil {
	if o == nil || IsNil(o.Until) {
		var ret WaitUntil
		return ret
	}
	return *o.Until
}

// GetUntilOk returns a tuple with the Until field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Wait) GetUntilOk() (*WaitUntil, bool) {
	if o == nil || IsNil(o.Until) {
		return nil, false
	}
	return o.Until, true
}

// HasUntil returns a boolean if a field has been set.
func (o *Wait) HasUntil() bool {
	if o != nil && !IsNil(o.Until) {
		return true
	}

	return false
}

// SetUntil gets a reference to the given WaitUntil and assigns it to the Until field.
func (o *Wait) SetUntil(v WaitUntil) {
	o.Until = &v
}

// GetFailOnReach returns the FailOnReach field value
func (o *Wait) GetFailOnReach() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.FailOnReach
}

// GetFailOnReachOk returns a tuple with the FailOnReach field value
// and a boolean to check if the value has been set.
func (o *Wait) GetFailOnReachOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.FailOnReach, true
}

// SetFailOnReach sets field value
func (o *Wait) SetFailOnReach(v bool) {
	o.FailOnReach = v
}

func (o Wait) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Wait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Duration) {
		toSerialize["duration"] = o.Duration
	}
	if !IsNil(o.Until) {
		toSerialize["until"] = o.Until
	}
	toSerialize["fail_on_reach"] = o.FailOnReach
	return toSerialize, nil
}

type NullableWait struct {
	value *Wait
	isSet bool
}

func (v NullableWait) Get() *Wait {
	return v.value
}

func (v *NullableWait) Set(val *Wait) {
	v.value = val
	v.isSet = true
}

func (v NullableWait) IsSet() bool {
	return v.isSet
}

func (v *NullableWait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWait(val *Wait) *NullableWait {
	return &NullableWait{value: val, isSet: true}
}

func (v NullableWait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


